alives = 50
blives = 50
gameon = 1
escalation = 1
spawnedtimes = 0
players = {}

SpawnZombies = function()
	local route = Utils.RandomInteger(0,2)
	local zombos = Utils.RandomInteger(1,escalation)
	if zombos > 5 then
		zombos = 5
	end
	local zdogs = Utils.RandomInteger(1,50)
	SpawnZombiesA(route,zombos,zdogs)
	SpawnZombiesB(route,zombos,zdogs)
	local spawntime = Utils.RandomInteger(1,8) - escalation
	if spawntime < 0 then
		spawntime = 1
	end
	Trigger.AfterDelay(DateTime.Seconds(spawntime), function()
		SpawnZombies()
	end)
	spawnedtimes = spawnedtimes + 1
	if spawnedtimes == 10 then
		escalation = 2
	elseif spawnedtimes == 30 then
		escalation = 3
	elseif spawnedtimes == 60 then
		escalation = 4
	end
end

SpawnZombiesA = function(route1,zombos1,zdogs)
	local route = route1
	local zombos = zombos1
	local spawnedunits = ""
	if zdogs < 20 then
		spawnedunits = "zdog"
	else
		spawnedunits = "zombie"
	end
	if route == 1 then
		while zombos > 0 do
			local creeps = Player.GetPlayer("Neutral")
			local actor = Actor.Create(spawnedunits, true, { Owner = creeps, Location = al1.Location })
			actor.Move(al2.Location)
			zombos = zombos - 1
		end
	else
		while zombos > 0 do
			local creeps = Player.GetPlayer("Neutral")
			local actor = Actor.Create(spawnedunits, true, { Owner = creeps, Location = ar1.Location })
			actor.Move(ar2.Location)
			zombos = zombos - 1
		end
	end
end

SpawnZombiesB = function(route1,zombos1,zdogs)
	local route = route1
	local zombos = zombos1
	local spawnedunits = ""
	if zdogs < 20 then
		spawnedunits = "zdog"
	else
		spawnedunits = "zombie"
	end
	if route == 1 then
		while zombos > 0 do
			local creeps = Player.GetPlayer("Neutral")
			local actor = Actor.Create(spawnedunits, true, { Owner = creeps, Location = bl1.Location })
			actor.Move(bl2.Location)
			zombos = zombos - 1
		end
	else
		while zombos > 0 do
			local creeps = Player.GetPlayer("Neutral")
			local actor = Actor.Create(spawnedunits, true, { Owner = creeps, Location = br1.Location })
			actor.Move(br2.Location)
			zombos = zombos - 1
		end
	end
end

Mover = function()
	Trigger.OnEnteredFootprint({al2.Location}, function(actor,id)
		if actor.IsDead == false then
			actor.Move(al3.Location)
		end
	end)
	Trigger.OnEnteredFootprint({al3.Location}, function(actor,id)
		if actor.IsDead == false then
			actor.Move(ae1.Location)
		end
	end)
	Trigger.OnEnteredFootprint({ae1.Location}, function(actor,id)
		if actor.IsDead == false then
			actor.Move(ae2.Location)
		end
	end)
	Trigger.OnEnteredFootprint({ar2.Location}, function(actor,id)
		if actor.IsDead == false then
			actor.Move(ar3.Location)
		end
	end)
	Trigger.OnEnteredFootprint({ar3.Location}, function(actor,id)
		if actor.IsDead == false then
			actor.Move(ae1.Location)
		end
	end)
	Trigger.OnEnteredFootprint({ae2.Location}, function(actor,id)
		actor.Destroy()
		alives = alives - 1
		UpdateMissionText()
	end)
	
	Trigger.OnEnteredFootprint({bl2.Location}, function(actor,id)
		if actor.IsDead == false then
			actor.Move(bl3.Location)
		end
	end)
	Trigger.OnEnteredFootprint({bl3.Location}, function(actor,id)
		if actor.IsDead == false then
			actor.Move(be1.Location)
		end
	end)
	Trigger.OnEnteredFootprint({be1.Location}, function(actor,id)
		if actor.IsDead == false then
			actor.Move(be2.Location)
		end
	end)
	Trigger.OnEnteredFootprint({br2.Location}, function(actor,id)
		if actor.IsDead == false then
			actor.Move(br3.Location)
		end
	end)
	Trigger.OnEnteredFootprint({br3.Location}, function(actor,id)
		if actor.IsDead == false then
			actor.Move(be1.Location)
		end
	end)
	Trigger.OnEnteredFootprint({be2.Location}, function(actor,id)
		actor.Destroy()
		blives = blives - 1
		UpdateMissionText()
	end)
end

UpdateMissionText = function()
	if alives < 1 then
		gameon = 0
	end
	if blives < 1 then
		gameon = 0
	end
	if gameon == 1 then
		UserInterface.SetMissionText("Team 1 lives: " .. alives .. "\nTeam 2 lives: " .. blives, HSLColor.White)
	else
		UserInterface.SetMissionText("Game over!", HSLColor.White)
		DecideWinner()
	end
end

DecideWinner = function()
	if alives < 1 then
		KillAnt(players[1])
	elseif blives < 1 then
		KillAnt(players[2])
	end
end

KillAnt = function(player)
	local ant = player.GetActorsByType("antfire")[1]
	if ant ~= nil then
		if ant.IsDead == false then
			ant.Kill()
		end
	end
end

SetCamera = function(player)
	local ant = player.GetActorsByType("antfire")[1]
	Camera.Position = ant.CenterPosition
end

StartingTexts = function()
	Media.DisplayMessage("Even giant ants are having a hard time protecting themselves against the undead hordes!")
	Trigger.AfterDelay(DateTime.Seconds(5), function()
		Media.DisplayMessage("Protect the hive entrance longer than your competitors!")
	end)
	Trigger.AfterDelay(DateTime.Seconds(10), function()
		Media.DisplayMessage("Good luck commander!")
		SpawnZombies()
	end)
end

WorldLoaded = function()
	players[1] = Player.GetPlayer("Multi0")
	players[2] = Player.GetPlayer("Multi1")
	for i = 1, 10 do
		if players[i] ~= nil then
			if players[i].IsLocalPlayer then
				SetCamera(players[i])
			end
		end
	end
	UpdateMissionText()
	Mover()
	StartingTexts()
end